#include<bits/stdc++.h>

using namespace std;
main()
{
    int t,x,x1;
    int n,m;
    cin>>t;
    int e[t];

    for(int i=0;i<t;i++)
    {
        cin>>n>>m;
        long int a[n],b[m];

        for(int j=0;j<n;j++)
            cin>>a[j];

        for(int k=0;k<m;k++)
            cin>>b[k];

        sort(a,a+n, greater<int>());
        long int c[n-1];
        x=a[0]-a[1];
        for(int g=0;g<n-1;g++)
        {
            c[g]=a[g]-a[g+1];
            if(c[g]<=x);
                x=c[g];
        }
        long int d[(n-1)/2+1];
        int q;
        for(int f=1;f<=x;f++)
        {
            q=0;
            if(x%f==0)
            {
                d[q]=f;
                q++;
            }
        }
        d[q]=x;

        sort(a,a+n);
        for(int s=0;s<n-1;s++)
        {
            for(int r=0;r<q+1;r++)
            {
                if(c[s]%d[r]==0)
                    x1=d[r];
            }
        }
        int io;

        for(int v=0;v<n;v++)
        {
            for(int j=0;j<m;j++)
            {
                if(a[v]+x1==b[j] || a[v]-x1==b[j])
                    io=0;
                else
                    if(io!=0)
                        io=1;
            }
        }
        e[i]=io;
        io=1;
    }
    for(int i=0;i<t;i++)
        cout<<e[i]<<endl;
}